package keystash.gui;

import static keystash.KeyStashGUI.encryptDatabaseEntropyValue;
import static keystash.KeyStashGUI.encryptDatabaseLengthValue;
import static keystash.KeyStashGUI.encryptDatabasePasswordField;
import static keystash.KeyStashGUI.encryptDatabasePasswordStrengthLabel;
import static keystash.KeyStashGUI.encryptDatabasejProgressBar;
import static keystash.KeyStashGUI.newAccountEntropyValue;
import static keystash.KeyStashGUI.newAccountLengthValue;
import static keystash.KeyStashGUI.newAccountPasswordField;
import static keystash.KeyStashGUI.newAccountPasswordStrengthLabel;
import static keystash.KeyStashGUI.newAccountjProgressBar;
import keystash.util.Convert;
import keystash.util.Memory;
import keystash.util.PasswordStrength;

public class Complexity {

    public static void newAccountPasswordField() {

        char[] checkPassword = newAccountPasswordField.getPassword();
        newAccountLengthValue.setText(Convert.intToString(checkPassword.length));
        double shannonEntropy = PasswordStrength.getShannonEntropy(new String(checkPassword));
        newAccountEntropyValue.setText(String.valueOf(shannonEntropy));
        int showPasswordStrenght = PasswordStrength.checkPasswordStrength(new String(checkPassword));
        long shannonLong = (long) shannonEntropy;

        if (showPasswordStrenght == 0 && shannonLong <= 1) {
            newAccountjProgressBar.setValue(0);
            newAccountPasswordStrengthLabel.setText("Complexity:");
        }

        if (showPasswordStrenght >= 25 && shannonLong == 2) {
            newAccountjProgressBar.setValue(25);
            newAccountPasswordStrengthLabel.setText("Complexity: Weak");
        }

        if (showPasswordStrenght >= 50 && shannonLong == 3) {
            newAccountjProgressBar.setValue(50);
            newAccountPasswordStrengthLabel.setText("Complexity: Good");
        }

        if (showPasswordStrenght >= 75 && shannonLong == 4) {
            newAccountjProgressBar.setValue(75);
            newAccountPasswordStrengthLabel.setText("Complexity: Very good");
        }

        if (showPasswordStrenght == 100 && shannonLong == 5) {
            newAccountjProgressBar.setValue(100);
            newAccountPasswordStrengthLabel.setText("Complexity: Strong");
        }

        if (checkPassword.length <= 5) {
            newAccountjProgressBar.setValue(0);
            newAccountPasswordStrengthLabel.setText("Complexity: Very weak");
        }

        if (checkPassword.length == 0) {
            newAccountjProgressBar.setValue(0);
            newAccountPasswordStrengthLabel.setText("Complexity:");
        }

        Memory.clearPasswordMemory(checkPassword);

    }

    public static void encryptDatabase() {

        char[] checkPassword = encryptDatabasePasswordField.getPassword();
        encryptDatabaseLengthValue.setText(Convert.intToString(checkPassword.length));
        double shannonEntropy = PasswordStrength.getShannonEntropy(new String(checkPassword));
        encryptDatabaseEntropyValue.setText(String.valueOf(shannonEntropy));
        int showPasswordStrenght = PasswordStrength.checkPasswordStrength(new String(checkPassword));
        long shannonLong = (long) shannonEntropy;

        if (showPasswordStrenght == 0 && shannonLong <= 1) {
            encryptDatabasejProgressBar.setValue(0);
            encryptDatabasePasswordStrengthLabel.setText("Complexity:");
        }

        if (showPasswordStrenght >= 25 && shannonLong == 2) {
            encryptDatabasejProgressBar.setValue(25);
            encryptDatabasePasswordStrengthLabel.setText("Complexity: Weak");
        }

        if (showPasswordStrenght >= 50 && shannonLong == 3) {
            encryptDatabasejProgressBar.setValue(50);
            encryptDatabasePasswordStrengthLabel.setText("Complexity: Good");
        }

        if (showPasswordStrenght >= 75 && shannonLong == 4) {
            encryptDatabasejProgressBar.setValue(75);
            encryptDatabasePasswordStrengthLabel.setText("Complexity: Very good");
        }

        if (showPasswordStrenght == 100 && shannonLong == 5) {
            encryptDatabasejProgressBar.setValue(100);
            encryptDatabasePasswordStrengthLabel.setText("Complexity: Strong");
        }

        if (checkPassword.length <= 5) {
            encryptDatabasejProgressBar.setValue(0);
            encryptDatabasePasswordStrengthLabel.setText("Complexity: Very weak");
        }

        if (checkPassword.length == 0) {
            encryptDatabasejProgressBar.setValue(0);
            encryptDatabasePasswordStrengthLabel.setText("Complexity:");
        }

        Memory.clearPasswordMemory(checkPassword);

    }

}
